from cefpython3 import cefpython as cef
import serial.tools.list_ports
import sys

serial2usb_description = "FT232R USB UART"
baud_rate = 57600

ports = serial.tools.list_ports.comports()
serial_port = None
for port in ports:
    print(port.description)
    print(port.device)
    if serial2usb_description in port.description:
        serial_port = port
device = serial.Serial(serial_port.device, baud_rate)

sys.excepthook = cef.ExceptHook  # To shutdown all CEF processes on error
cef.Initialize()
browser = cef.CreateBrowserSync(url="file:///Users/vincentzhou/PycharmProjects/FabInterface/src/interface.html",
                                window_title="Interface")

def serial_send_string(string):
    device.write(string.encode())
    print("send: " + string)

def serial_clear_string():
    device.write("\\".encode())
    print("cleared")

bindings = cef.JavascriptBindings(bindToFrames=False, bindToPopups=False)
bindings.SetFunction("serial_send_string", serial_send_string)
bindings.SetFunction("serial_clear_string", serial_clear_string)
browser.SetJavascriptBindings(bindings)

cef.MessageLoop()
device.close()
cef.Shutdown()